unit MSNPopup;

interface

uses
  SysUtils, Classes, Windows, Forms, uPopup, ExtCtrls, Dialogs;

type
  TMSNPopup = class(TComponent)
  private
    FTitle: string;
    FMessage: string;
    FTop: Integer;
    FTimer: TTimer;
    FMaxTimeShow: Integer;
    FShowPopup: Integer;
    procedure SetTitle(Value: string);
    procedure SetMessage(Value: string);
    procedure SetMaxTimeSowPopup(Value: Integer);
    procedure StartClosePopup(Sender: TObject);
  protected
    procedure ClosePopup;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Popup;
    
  published
    property Title: string read FTitle write SetTitle;
    property TextMessage: string read FMessage write SetMessage;
    property TimeShowPopu: Integer read FMaxTimeShow write SetMaxTimeSowPopup default 5;
  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('HK Sistemas', [TMSNPopup]);
end;

{ TMSNPopup }

constructor TMSNPopup.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  fMSNPopup := TfMSNPopup.Create(Application);
  FTimer:= TTimer.Create(Self);
  FTimer.Interval:= 1000;
  FTimer.OnTimer:=  StartClosePopup;
  FTimer.Enabled:= False;
  FShowPopup:= 1;
  FMaxTimeShow:= 5;
end;

destructor TMSNPopup.Destroy;
begin
  inherited Destroy;
end;

procedure TMSNPopup.ClosePopup;
var
  I: Integer;
  BarraIniciar: HWND;
  tmAltura: Integer;
  tmRect: TRect;
  xTop: Integer;
  xIniTop: Integer;
begin

  BarraIniciar := FindWindow('Shell_TrayWnd', nil);
  GetWindowRect(BarraIniciar, tmRect);
  tmAltura := tmRect.Bottom - tmRect.Top;
  with fMSNPopup do
  begin
    xTop := Screen.Height - ClientHeight - tmAltura;
    xIniTop := Screen.Height ;//+ ClientHeight + tmAltura;
    Top := FTop;
    for I := xTop to xIniTop do
    begin
      Top := Top + 1;
      Update;
      Application.ProcessMessages;
      Sleep(3);
    end;
   Close;
  end;
end;

procedure TMSNPopup.Popup;
var
  I: Integer;
  BarraIniciar: HWND;
  tmAltura: Integer;
  tmRect: TRect;
  xTop: Integer;
  xIniTop: Integer;
begin
  BarraIniciar := FindWindow('Shell_TrayWnd', nil);
  GetWindowRect(BarraIniciar, tmRect);
  tmAltura := tmRect.Bottom - tmRect.Top;
  with fMSNPopup do
  begin
  Show;
    Left := Screen.Width - ClientWidth - 10;
    xTop := Screen.Height - ClientHeight - tmAltura;
    xIniTop := Screen.Height ;//+ ClientHeight + tmAltura;
    Top := xIniTop;  
    for I := xIniTop downto xTop do
    begin
      Top := Top - 1;

      Update;
      Application.ProcessMessages;
      Sleep(1);
    end;
    FTop:= Top;
    FTimer.Enabled:= True;
  end;

end;

procedure TMSNPopup.SetMessage(Value: string);
begin
  if FMessage <> Value then
  begin
    FMessage := Value;
    fMSNPopup.LbMsg.Caption := Value;
  end;
end;

procedure TMSNPopup.SetTitle(Value: string);
begin
  if FTitle <> Value then
  begin
    FTitle := Value;
    fMSNPopup.LbTitle.Caption := Value;
  end;
end;

procedure TMSNPopup.StartClosePopup(Sender: TObject);
begin
   FShowPopup:= FShowPopup + 1;
   if FShowPopup = FMaxTimeShow then
   begin
   ClosePopup;
   FShowPopup:=1;
   FTimer.Enabled:= False;
   end;
end;

procedure TMSNPopup.SetMaxTimeSowPopup(Value: Integer);
begin
if FMaxTimeShow <> Value then
FMaxTimeShow:= Value;
end;

end.

